#ifndef NEMO_FMT_H
#define NEMO_FMT_H

#ifdef __cplusplus
extern "C" {
#endif

/*
  enough space to hold:
    optional '-' or '+',
    2^128 - 1 in decimal,
    plus \0
*/
#define FMT_LONG 41

#define FMT_ULONG FMT_LONG

/*
  convenient abbreviation
*/
#define FMT_LEN ((void *) 0)

unsigned int	fmt_8long(void *out, unsigned long u);
unsigned int	fmt_hexb(void *out, const void *buff, unsigned int len);
unsigned int	fmt_long(void *out, long u);
unsigned int	fmt_long0(void *out, long u, unsigned int size);
unsigned int	fmt_minus(void *out, long i);
unsigned int	fmt_plusminus(void *out, long i);
unsigned int	fmt_str(void *out, const char *t);
unsigned int	fmt_strn(void *out, const void *t, unsigned int len);
unsigned int	fmt_uint(void *out, unsigned int u);
unsigned int	fmt_uint0(void *out, unsigned int u, unsigned int size);
unsigned int	fmt_ulong(void *out, unsigned long u);
unsigned int	fmt_ulong0(void *out, unsigned long u, unsigned int size);
unsigned int	fmt_xlong(void *out, unsigned long u);
/*
unsigned int	fmt_xint(void *out, unsigned int u);
unsigned int	fmt_nbbint(void *out, unsigned int, unsigned int, unsigned int, unsigned int);
unsigned int	fmt_ushort(void *out, unsigned short);
unsigned int	fmt_xshort(void *out, unsigned short);
unsigned int	fmt_nbbshort(void *out, unsigned int, unsigned int, unsigned int, unsigned short);
unsigned int	fmt_nbblong(void *, unsigned int, unsigned int, unsigned int, unsigned long);
unsigned int	fmt_0x(void *out, int);
*/

#ifdef __cplusplus
}
#endif

#endif
