#include "stdint.h"
#include "ip4.h"
#include "ip6.h"

void ip6_mask_0(ip6_address *ip, unsigned int mask_depth)
{
  unsigned int first_byte;
  unsigned int i;
  byte_t ch;

  if (mask_depth > 128) {
    mask_depth = 128;
  }
  first_byte = mask_depth >> 3;  /* div by 8 (bits/byte) */
  if (mask_depth & 7) {
    first_byte++;  /* skip part byte */
  }
  for (i = first_byte; i < 16; i++) {
    ip->d[i] = '\0';
  }

  i = 8 - (mask_depth & 7);  /* shift count (from mod 8) */
  if (i == 8) return;  /* byte boundary */

  first_byte--;  /* revert to part byte */
  ch = (byte_t)(ip->d[first_byte] >> i);
  ip->d[first_byte] = (byte_t)(ch << i);
}
