#include "stdint.h"
#include "ip4.h"
#include "ip6.h"

unsigned int ip6_vector_find(register const ip6_vector *v, register const ip6_address *ip)
{
  register int low;
  register int mid;
  register int high;
  register int cond;
  low = 0;
  high = (int)(v->len) - 1;
  while (low <= high) {
    mid = (low + high) / 2;
    cond = ip6_diff(ip, &v->va[mid]);
    if (cond == 0) return (unsigned int)mid;
    if (cond < 0) {
      high = mid - 1;
    }
    else {
      low = mid + 1;
    }
  }
  return v->len;
}
