#include "stralloc.h"
#include "alloc.h"
#include "str.h"
#include "byte.h"
#include "env.h"
#include "pathexec.h"

static stralloc plus = STRALLOC;
static stralloc tmp = STRALLOC;

unsigned int pathexec_env(register const char *s, const char *t)
{
  if (!s) return 1;
  if (!stralloc_copys(&tmp, s)) return 0;
  if (t) {
    if (!stralloc_cats(&tmp, "=")) return 0;
    if (!stralloc_cats(&tmp, t)) return 0;
  }
  if (!stralloc_0(&tmp)) return 0;
  return stralloc_cat(&plus, &tmp);
}

void pathexec(char **argv)
{
  register char **e;
  register unsigned int e_len;
  register unsigned int i;
  register unsigned int j;
  unsigned int split;
  unsigned int t;

  if (!stralloc_0(&plus)) return;

  e_len = 0;
  for (i = 0; environ[i]; ++i) {
    ++e_len;
  }
  for (i = 0; i < plus.len; ++i) {
    if (!plus.s[i]) {
      ++e_len;
    }
  }

  e = (char**) alloc((e_len + 1) * sizeof(char *));
  if (!e) return;

  e_len = 0;
  for (i = 0; environ[i]; ++i) {
    e[e_len++] = environ[i];
  }

  j = 0;
  for (i = 0; i < plus.len; ++i) {
    if (!plus.s[i]) {
      split = str_chr(plus.s + j, '=');
      for (t = 0; t < e_len; ++t) {
        if (byte_equal(plus.s + j, split, e[t])) {
          if (e[t][split] == '=') {
            --e_len;
            e[t] = e[e_len];
            break;
          }
        }
      }
      if (plus.s[j + split]) {
        e[e_len++] = plus.s + j;
      }
      j = i + 1;
    }
  }
  e[e_len] = 0;

  pathexec_run(*argv, argv, e);
  alloc_free(e);
}
