#include "stralloc.h"
#include "sa_vector.h"
/*
  NB: this routine requires the vector to be sorted
*/
unsigned int sa_vector_case_find(register const sa_vector *v, register const stralloc *target)
{
  register int low;
  register int mid;
  register int high;
  register int cond;
  low = 0;
  high = (int)(v->len) - 1;
  while (low <= high) {
    mid = (low + high) / 2;
    cond = stralloc_case_diff(target, &v->va[mid]);
    if (!cond) return (unsigned int)mid;
    if (cond < 0) {
      high = mid - 1;
    }
    else {
      low = mid + 1;
    }
  }
  return v->len;
}
