#ifndef NEMO_SIG_H
#define NEMO_SIG_H

#ifdef __cplusplus
extern "C" {
#endif

extern const int sig_alarm;
extern const int sig_child;
extern const int sig_cont;
extern const int sig_hangup;
extern const int sig_pipe;
extern const int sig_term;
extern const int sig_kill;
extern const int sig_int;

extern void (*sig_defaulthandler)(int);
extern void (*sig_ignorehandler)(int);

void	sig_catch(int sig, void (*f)(int));
#define sig_ignore(s) (sig_catch((s), sig_ignorehandler))
#define sig_uncatch(s) (sig_catch((s), sig_defaulthandler))

void	sig_block(int sig);
void	sig_unblock(int sig);
void	sig_blocknone(void);
void	sig_pause(void);

/* extern void sig_dfl(); */

void	sig_miscignore(void);
void	sig_bugcatch(void (*f)(int));

void	sig_pipeignore(void);
void	sig_pipedefault(void);

/*
extern void sig_contblock();
extern void sig_contunblock();
extern void sig_contcatch();
extern void sig_contdefault();
*/
void	sig_termblock(void);
void	sig_termunblock(void);
void	sig_termcatch(void (*f)(int));
void	sig_termdefault(void);

void	sig_alarmblock(void);
void	sig_alarmunblock(void);
void	sig_alarmcatch(void (*f)(int));
void	sig_alarmdefault(void);

void	sig_childblock(void);
void	sig_childunblock(void);
void	sig_childcatch(void (*f)(int));
void	sig_childdefault(void);

void	sig_hangupblock(void);
void	sig_hangupunblock(void);
void	sig_hangupcatch(void (*f)(int));
void	sig_hangupdefault(void);

const char *sig_name(int sig);
const char *sig_str(int sig);

#ifdef __cplusplus
}
#endif

#endif
