/* Public domain. */

#include <signal.h>
#include "sig.h"

#define X(e, s) if (i == e) return s;

const char *sig_str(register int i)
{
  X(sig_hangup, "Hangup")
  X(SIGINT, "Interrupt")
  X(SIGQUIT, "Quit")
  X(SIGILL, "Illegal instruction")
  X(SIGTRAP, "Trace/breakpoint trap")
  X(SIGABRT, "Abort")
#ifdef SIGEMT
  X(SIGEMT, "EMT instruction")  /* non-posix */
#endif
  X(SIGFPE, "Floating point exception")
  X(sig_kill, "Kill")
  X(SIGBUS, "Bus error")
  X(SIGSEGV, "Invalid memory reference")
  X(SIGSYS, "Bad system call")
  X(sig_pipe, "Write on a pipe with no one to read it")
  X(sig_alarm, "Real-time timer expired")
  X(sig_term, "Termination signal")
  X(SIGURG, "Urgent condition on IO channel")
  X(SIGSTOP, "Stop executing")
  X(SIGTSTP, "Terminal stop signal")
  X(sig_cont, "Continue a stopped process")
  X(sig_child, "Child process status changed")
  X(SIGTTIN, "Background process attempting read")
  X(SIGTTOU, "Background process attempting write")
#ifdef SIGIO
  X(SIGIO, "Input/output possible signal")  /* non-posix */
#endif
  X(SIGXCPU, "CPU time limit exceeded")
  X(SIGXFSZ, "File size limit exceeded")
  X(SIGVTALRM, "Virtual timer expired")
  X(SIGPROF, "Profiling timer expired")
#ifdef SIGWINCH
  X(SIGWINCH, "Window size changes")  /* non-posix */
#endif
#ifdef SIGINFO
  X(SIGINFO, "Information request")  /* non-posix */
#endif
  X(SIGUSR1, "User-defined signal 1")
  X(SIGUSR2, "User-defined signal 2")
#ifdef SIGTHR
  X(SIGTHR, "Thread interrupt")  /* non-posix */
#endif
#ifdef SIGCKPT
  X(SIGCKPT, "Checkpoint and continue")  /* non-posix */
#endif
#ifdef SIGCKPTEXIT
  X(SIGCKPTEXIT, "Checkpoint and exit")  /* non-posix */
#endif
#ifdef SIGPWR
  X(SIGPWR, "Power failure")  /* non-posix */
#endif
#ifdef SIGLOST
  X(SIGLOST, "File lock is lost")  /* non-posix */
#endif
#ifdef SIGPOLL
  X(SIGPOLL, "Pollable event")  /* non-bsd */
#endif
  return 0;
}
