#include "stdint.h"
#include "stralloc.h"
#include "char.h"
#include "error.h"

/*
  1 --> OK
  0 --> memory exhasted
*/

#define SHIFT	4

unsigned int stralloc_hex_decode(stralloc *out, const stralloc *in)
{
  static stralloc tmp = STRALLOC;
  register byte_t v;
  register unsigned int i;
  register unsigned int len;
  char ch;

  len = in->len;
  if (!len) return stralloc_erase(out);
  if (len & 0x01) {  /* uneven */
    errno = error_proto;
    return 0;
  }
  if (!stralloc_erase(&tmp)) return 0;
  ch = '\0';
  for (i = 0; i < len; i++) {
    v = char_hex_table[(byte_t)in->s[i]];
    if (v & 0xf0) {  /* greater than 15 - error */
      errno = error_proto;
      return 0;
    }
    ch = (char)(ch | v);
    if (!(i & 0x01)) {
      ch = (char)(ch << SHIFT);
      continue;
    }
    if (!stralloc_append(&tmp, &ch)) return 0;
    ch = '\0';
  }
  return stralloc_copy(out, &tmp);
}
