#ifndef NEMO_TAIA_H
#define NEMO_TAIA_H

#ifdef __cplusplus
extern "C" {
#endif

struct taia {
  struct tai sec;
  unsigned long nano; /* 0...999999999 */
  unsigned long atto; /* 0...999999999 */
};

#define TAIA { TAI, 0, 0 }

void		taia_tai(const struct taia *ta, struct tai *t);
void		taia_uint(struct taia *t, unsigned int u);

void		taia_unix(struct taia *t, time_t u);
time_t		taia_epoch(const struct taia *t);
uint64_t	taia_seconds(const struct taia *t);

void		taia_now(struct taia *t);

double		taia_approx(const struct taia *t);
double		taia_frac(const struct taia *t);

void		taia_add(struct taia *t, const struct taia *u, const struct taia *v);
void		taia_sub(struct taia *t, const struct taia *u, const struct taia *v);
void		taia_half(struct taia *t, const struct taia *u);

unsigned int	taia_less(const struct taia *t, const struct taia *u);

#define TAIA_PACK 16

void		taia_pack(const struct taia *t, void *d);
void		taia_unpack(struct taia *t, const void *d);

#define TAIA_FMTFRAC 19

unsigned int	taia_fmtfrac(const struct taia *t, void *d);

#define TAIA_TIMESTAMP 26

unsigned int	taia_timestamp(void *out);

#ifdef __cplusplus
}
#endif

#endif
