#include "stdint.h"
#include "unixtypes.h"
#include "select.h"
#include "open.h"
#include "fifo.h"
#include "unix.h"

void _exit(int);

#define FN "temp-trynpbg1.fifo"

int main(int argc, char **argv)
{
  int flag_bug;
  struct timeval instant;
  fd_set rfds;

  if (argc != 1) return 111;  /* keep compiler quiet */
  if (!*argv[0]) return 111;  /* keep compiler quiet */

  flag_bug = 0;
  if (fifo_make(FN, 0600) != -1) {
    close(0);
    if (open_read(FN) == 0) {
      FD_ZERO(&rfds);
      FD_SET(0, &rfds);
      instant.tv_sec = instant.tv_usec = 0;
      if (select(1, &rfds, (fd_set*)0, (fd_set*)0, &instant) > 0) {
        flag_bug = 1;
      }
    }
    unlink(FN);
  }
  _exit(!flag_bug);
  return (!flag_bug);  /* lint - older compilers */
}
